#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <QDebug>
#include <QFileDialog>
#include <QSettings>
//#include <cmath>
#include <math.h>


MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
  version = "V2.00";
  verdatum = " vom 25.09.2014";

  ui->setupUi(this);
  //ui->lcdNumber_dBmpep->display(2.334);
  rs232 = new Modem;
  QObject::connect( rs232, SIGNAL(setTtyText(QString)), this, SLOT(setAText(QString)));
  rs232isopen = false;
  rs232timer = new QTimer();
  QObject::connect( rs232timer, SIGNAL(timeout()), this, SLOT(getrs232()));
  QObject::connect( ui->actiond_holen, SIGNAL(activated()), this, SLOT(datenholen()));
  QObject::connect( ui->action_Speichern, SIGNAL(activated()), this, SLOT(datenspeichern()));

  openttytimer = new QTimer(this);
  QObject::connect(openttytimer, SIGNAL(timeout()), this, SLOT(fopentty() ));
#ifdef Q_WS_WIN
  int i;
  QString qs;
  for(i=1;i<=20;i++){
    qs.sprintf("COM%i",i);
    listtty.append(qs);
  }
#else
  listtty.append("/dev/ttyUSB0");
  listtty.append("/dev/ttyUSB1");
  listtty.append("/dev/ttyUSB2");
  listtty.append("/dev/ttyUSB3");
#endif
  idtty = 0; //mit Index 0 beginnen
  bvantwort = FALSE;
  bmwgefunden = FALSE;

  openttytimer->start(200);
  bbegin = false;
  mknummer = 0;
  mktype = 0;
  mkdbmax = 5.0;
  dbatt = 0.0;

}

MainWindow::~MainWindow()
{
  rs232->writeLine("#c;"); //Befehl zum Schliessen der RS232
  delete ui;
}

void MainWindow::setAText(QString stty){
  QString qs;
  QString sfw;

  qs = tr("mWattmeter");
  if(bmwgefunden){
    sfw.sprintf("FW:%i.xx",mwversion / 10);
  }else{
    sfw = "FW:?";
  }
  QString astty = qs + " - " + version + " - " + sfw + " - " + stty;
  setWindowTitle(astty);
}

void MainWindow::getrs232(){
  char abuffer[1000];
  int gelesen;
  char c;
  double volt;
  double watt;
  QString qs1, qs2;
  bool ok;

  if(rs232isopen){
    gelesen = rs232->readttybuffer(abuffer, 1000);
    for(int i=0;i<gelesen;i++){
      buffer[widxbuffer] = abuffer[i];
      widxbuffer++;
      if(widxbuffer == 1000)widxbuffer=0;
    }
  }
  while(widxbuffer != ridxbuffer){
    c = buffer[ridxbuffer];
    if(bbegin){
      switch(c){
      case ';':
        switch(ebefehl)
        {
        case ekanala: // Befehl @axx,xx; dBm RMS
          sbefehl.remove(" ");
          volt = sbefehl.toDouble(&ok);
          if((mktype == 1) or (mktype == 3)){
            sbefehl.sprintf("%3.1f dBV",volt);
            volt = pow(10.0 , volt/20.0);
          }else{
            sbefehl.sprintf("%3.1f dBm",volt);
            volt = sqrt((pow(10.0 , volt/10.0) * 0.001) * 50.0);
          }
          ui->labelNdbmrms->setText(sbefehl);
          sbefehl = vanpassen(volt);
          ui->labelNvoltrms->setText(sbefehl);
          if((mktype == 1) or (mktype == 3)){
            ui->labelNwattrms->setText("");
          }else{
            watt = volt * volt / 50.0;
            sbefehl = wanpassen(watt);
            ui->labelNwattrms->setText(sbefehl);
          }
          break;
        case ekanalb: // Befehl @bxx,xx; dBm PEP
          sbefehl.remove(" ");
          volt = sbefehl.toDouble();
          if((mktype == 1) or (mktype == 3)){
            sbefehl.sprintf("%3.1f dBV",volt);
            volt = pow(10.0 , volt/20.0);
          }else{
            sbefehl.sprintf("%3.1f dBm",volt);
            volt = sqrt((pow(10.0 , volt/10.0) * 0.001) * 50.0);
          }
          ui->labelNdbmpep->setText(sbefehl);
          sbefehl = vanpassen(volt);
          ui->labelNvoltpep->setText(sbefehl);
          if((mktype == 1) or (mktype == 3)){
            ui->labelNwattpep->setText("");
          }else{
            watt = volt * volt / 50.0;
            sbefehl = wanpassen(watt);
            ui->labelNwattpep->setText(sbefehl);
          }
          break;
        case edatakopf: // Befehl @kxxxxx,yy; Datenkopf x= Anzahl der Datensaetze y= Sekunden
            //qDebug()<<sbefehl;
          qs1 = sbefehl.section("*",0,0); // x
          qs2 = sbefehl.section("*",1,1); // y
          mwdata.anzahl = qs1.toInt();
          mwdata.sekunden = qs2.toInt();
          break;
        case edata:     // Befehl @dxx,xx yy,yy; Daten x= dBmRMS
          //                             y= dBmPEP
            //qDebug()<<sbefehl;
          qs1 = sbefehl.section("*",0,0);
          qs2 = sbefehl.section("*",1,1);
          qs1.remove(" ");
          mwdata.dbmrms[idx] = (int) qs1.toDouble();
          qs2.remove(" ");
          mwdata.dbmpep[idx] = (int) qs2.toDouble();
          if(idx == mwdata.anzahl){
            fuellentxt();
            qs1.sprintf("Zwischenzeit %i Sek.",mwdata.sekunden);
            ui->labelsek->setText(qs1);
            qs1.sprintf("%i Datensaetze",mwdata.anzahl+1);
            ui->labelanzahl->setText(qs1);
            ui->Buttonrefresh->setEnabled(true);
          }
          idx++;
          if(idx>16000)idx=16000;
          break;
        case estatus:     // Befehl @s
          qs1 = sbefehl.section("*",0,0);
          mktype = qs1.toInt();
          qs1 = sbefehl.section("*",1,1);
          mknummer = qs1.toInt();
          qs1 = sbefehl.section("*",2,2);
          mkdbmax = qs1.toDouble();
          qs1 = sbefehl.section("*",3,3);
          dbatt = qs1.toDouble();
          qs1 = sbefehl.section("*",4,4);
          eustatus = (enumustatus) qs1.toInt();
          qs1.sprintf("%2i",mknummer);
          ui->labelmknr->setText(qs1);
          qs1.sprintf("%2.1f dBm",mkdbmax);
          ui->labeldbm->setText(qs1);
          qs1.sprintf("%2.1f dB",dbatt);
          ui->labelattdb->setText(qs1);
          switch(mktype){
          case 0: ui->labeladxx->setText("AD8362");
            break;
          case 1: ui->labeladxx->setText("AD8362 NF");
            break;
          case 2: ui->labeladxx->setText("AD8307");
            break;
          case 3: ui->labeladxx->setText("AD8307 NF");
            break;
          case 5: ui->labeladxx->setText("AD8361 linear");
            break;
          default: ui->labeladxx->setText("Unbekannt");
            break;
          }
          switch(eustatus){
          case enormal: ui->labelzsatz->setText("");
            break;
          case eaufzeichnung: ui->labelzsatz->setText("Funktion \"Aufzeichnung\" laeuft");
            break;
          }
          if((mktype == 1) or (mktype == 3)){
            ui->groupBoxrms->setTitle("Audio");
            ui->groupBoxpep->setTitle("Audio/Peak");
          }else{
            ui->groupBoxrms->setTitle("AVG/RMS");
            ui->groupBoxpep->setTitle("PEP");
          }
          break;
        }
        sbefehl="";
        bbegin = false;
        break;
      case 'a': ebefehl = ekanala;break;
      case 'b': ebefehl = ekanalb;break;
      case 'k': ebefehl = edatakopf;break;
      case 'd': ebefehl = edata;break;
      case 's': ebefehl = estatus;break;
      default: sbefehl=sbefehl+c;
      }
    }
    if(c=='@'){
      bbegin = true;
    }
    ridxbuffer++;
    if(ridxbuffer==1000)ridxbuffer=0;
  }
  rs232timer->start(100);
}

void MainWindow::fuellentxt(){
  QString qs, qs1;
  QString qstime;
  double dbmrms, dbmpep;
  QTime time;

  ui->textBrowser->clear();
  time = ui->timeEdit->time();
  ui->textBrowser->append("Datensatz \tZeitpunkt \tRMS \tPEP");
  ui->textBrowser->append("============================================");
  for(int i=0; i<=mwdata.anzahl;i++){
    time = time.addSecs(mwdata.sekunden);
    qstime = time.toString();
    dbmrms = double(mwdata.dbmrms[i]) / 100.0;
    dbmpep = double(mwdata.dbmpep[i]) / 100.0;
    qs.sprintf("%04.2f\t%04.2f\t dBm ", dbmrms, dbmpep);
    qs1.sprintf("%05i \t", i+1);
    ui->textBrowser->append(qs1 + qstime + "\t" + qs);
  }
  ui->action_Speichern->setEnabled(true);
}

void MainWindow::datenspeichern(){
  QFile file;
  QString fname, qs, qstime, pfad;
  QTime time;
  double dbmrms, dbmpep;
  QSettings settings("AFU", "mwmeter");

  pfad = settings.value("pfad", QDir::homePath()).toString();
  QDir d(pfad);
  //qDebug()<<d.absolutePath();
  fname = QFileDialog::getSaveFileName(this, tr("Speicher der Daten"),
                                       d.absolutePath(),
                                       tr("CSV (*.csv)"));
  if(!fname.isNull()){
    file.setFileName(fname);
    if(file.open(QIODevice::WriteOnly)){
      QTextStream ts(&file);
      time = ui->timeEdit->time();
      qs = ("Datensatz;Zeit;RMS;PEP");
      ts << qs << "\r\n";
      for(int i=0; i<=mwdata.anzahl; i++){
        time = time.addSecs(mwdata.sekunden);
        qstime = time.toString();
        //ts << qstime << ";";
        dbmrms = double(mwdata.dbmrms[i]) / 100.0;
        dbmpep = double(mwdata.dbmpep[i]) / 100.0;
        qs.sprintf("%5i;%s;%4.2f;%4.2f",i+1, qPrintable(qstime), dbmrms, dbmpep);
        ts << qs << "\r\n";
      }
      file.close();
      settings.setValue("pfad", fname);
    }
  }
}

void MainWindow::datenholen(){
  //qDebug() << "MainWindow::datenholen";
  //alles auf 0 setzen
  mwdata.anzahl = 0;
  mwdata.sekunden = 1;
  for(int i=0; i<16000;i++){
    mwdata.dbmrms[i]=0;
    mwdata.dbmpep[i]=0;
  }
  ui->tabWidget->setCurrentIndex(1);
  idx = 0; // Index auf erstes Feld setzen
  if(rs232isopen)rs232->writeLine("#d;"); //Befehl zum Holen der ext Eepromdaten
}

QString MainWindow::vanpassen(double v){
  QString qs;
  double a;

  a=v;
  if(a>=100.0){
    qs.sprintf("%3.1f V",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f V",a);
    return qs;
  }
  if(a>=1.0){
    qs.sprintf("%1.3f V",a);
    return qs;
  }
  a = a *1000.0;
  if(a>=100.0){
    qs.sprintf("%3.1f mV",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f mV",a);
    return qs;
  }
  if(a>=1.0){
    qs.sprintf("%1.3f mV",a);
    return qs;
  }
  a = a *1000.0;
  if(a>=100.0){
    qs.sprintf("%3.1f uV",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f uV",a);
    return qs;
  }
  if(a>=1.0){
    qs.sprintf("%1.3f uV",a);
    return qs;
  }
  a = a *1000.0;
  if(a>=100.0){
    qs.sprintf("%3.1f nV",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f nV",a);
    return qs;
  }
  qs.sprintf("%1.3f nV",a);
  return qs;
}

QString MainWindow::wanpassen(double v){
  QString qs;
  double a;

  a=v;
  if(a>=1000.0){
    qs.sprintf("%1.3f kW",a/1000.0);
    return qs;
  }
  if(a>=100.0){
    qs.sprintf("%3.1f W",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f W",a);
    return qs;
  }
  if(a>=1.0){
    qs.sprintf("%1.3f W",a);
    return qs;
  }
  a = a *1000.0;
  if(a>=100.0){
    qs.sprintf("%3.1f mW",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f mW",a);
    return qs;
  }
  if(a>=1.0){
    qs.sprintf("%1.3f mW",a);
    return qs;
  }
  a = a *1000.0;
  if(a>=100.0){
    qs.sprintf("%3.1f uW",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f uW",a);
    return qs;
  }
  if(a>=1.0){
    qs.sprintf("%1.3f uW",a);
    return qs;
  }
  a = a *1000.0;
  if(a>=100.0){
    qs.sprintf("%3.1f nW",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f nW",a);
    return qs;
  }
  if(a>=1.0){
    qs.sprintf("%1.3f nW",a);
    return qs;
  }
  a = a *1000.0;
  if(a>=100.0){
    qs.sprintf("%3.1f pW",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f pW",a);
    return qs;
  }
  if(a>=1.0){
    qs.sprintf("%1.3f pW",a);
    return qs;
  }
  a = a *1000.0;
  if(a>=100.0){
    qs.sprintf("%3.1f fW",a);
    return qs;
  }
  if(a>=10.0){
    qs.sprintf("%2.2f fW",a);
    return qs;
  }
  qs.sprintf("%1.3f fW",a);
  return qs;
}

void MainWindow::on_Buttonrefresh_clicked()
{
  fuellentxt();
}

void MainWindow::fopentty(){
  int gelesen=0;

  if(bvantwort){
    geraet = ' ';
    mwversion = 0;
    bvantwort = FALSE;
    if(rs232isopen)gelesen = rs232->readttybuffer(buffer, 2);
    //qDebug("gelesen: %i",gelesen);
    if(gelesen == 2){
      geraet = buffer[0];
      mwversion = int(buffer[1]);
      bvantwort = FALSE;
      //qDebug("gelesen: %i",gelesen);
      //qDebug("mwversion: %i",mwversion);
      if((geraet == 'M')and(mwversion > 10)){
        bmwgefunden = TRUE;
        openttytimer->stop(); //Suchen der Schnittstelle bendet
        statusBar()->showMessage(tr("HW gefunden an: ") + srs232);
        setAText(srs232);
        if(rs232isopen){
          rs232->writeLine("#o;"); //Befehl zum Oeffnen der RS232 im mW-Meter
          rs232timer->start(100);
          widxbuffer = 0;
          ridxbuffer = 0;
          ui->tabWidget->setEnabled(true);
        }
      }else{
        idtty++;
        if(idtty > (listtty.count()-1))idtty = 0;
        openttytimer->start(200); //Suchen der Schnittstelle
        rs232->closetty();
        rs232isopen = FALSE;
      }
    }else{
      idtty++;
      if(idtty > (listtty.count()-1))idtty = 0;
      openttytimer->start(200); //Suchen der Schnittstelle
      rs232->closetty();
      rs232isopen = FALSE;
    }
  }else{
    if(!rs232isopen){
      srs232 = listtty.at(idtty);
      statusBar()->showMessage("Suche HW :" + srs232);
      //qDebug(qPrintable(srs232));
      //qDebug("%i",idtty);
      rs232isopen = rs232->opentty(srs232);
      if(rs232isopen){
        //defaultlesentty();
        rs232->writeLine("#v;");
        bvantwort = TRUE;
        openttytimer->start(1000); //Suchen der Schnittstelle
      }else{
        idtty++;
        if(idtty > (listtty.count()-1))idtty = 0;
        openttytimer->start(100); //Suchen der Schnittstelle
        bvantwort = FALSE;
        rs232->closetty();
      }
    }
  }
}
