#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTimer>


#ifdef Q_WS_WIN
#include "win_modem.h"
#else
#include "lin_modem.h"
#endif

typedef struct {
  int anzahl;
  int sekunden;
  int dbmrms[16000];
  int dbmpep[16000];
}Tmwdata;

// die verschiedenen Befehle vom mWM
enum enumbefehl {ekanala, ekanalb, edatakopf, edata, estatus};
enum enumustatus {enormal=0, eaufzeichnung=1};

namespace Ui {
  class MainWindow;
}

class MainWindow : public QMainWindow
{
  Q_OBJECT

public:
  explicit MainWindow(QWidget *parent = 0);
  ~MainWindow();

public slots:
  void fuellentxt(void);

private:
  Ui::MainWindow *ui;
  Modem *rs232;
  QString version, verdatum;
  QStringList listtty;
  QTimer *openttytimer;

  int idtty;
  bool bvantwort;
  bool bmwgefunden;
  char geraet;
  int mwversion;
  QString srs232;

  bool rs232isopen;
  QTimer *rs232timer;
  char buffer[1000];
  int widxbuffer;
  int ridxbuffer;
  Tmwdata mwdata;
  enumbefehl ebefehl;
  enumustatus eustatus;
  QString sbefehl;
  bool bbegin;
  int idx;
  int mknummer;
  int mktype;
  double mkdbmax;
  double dbatt;


  QString vanpassen(double);
  QString wanpassen(double);


private slots:
  void on_Buttonrefresh_clicked();
  void setAText(QString);
  void getrs232();
  void datenholen();
  void fopentty();
  void datenspeichern();

};

#endif // MAINWINDOW_H
